﻿// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.

[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1020:AvoidNamespacesWithFewTypes", Scope = "namespace", Target = "Microsoft.Rest.Azure.OData", Justification = "OData specific extensions.")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1006:DoNotNestGenericTypesInMemberSignatures", Scope = "member", Target = "Microsoft.Rest.Azure.AzureClientExtensions.#GetPutOrPatchOperationResultAsync`1(Microsoft.Rest.Azure.IAzureClient,Microsoft.Rest.Azure.AzureOperationResponse`1<!!0>,System.Func`1<System.Threading.Tasks.Task`1<Microsoft.Rest.Azure.AzureOperationResponse`1<!!0>>>,System.Threading.CancellationToken)", Justification = "Necessary to support service clients.")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1054:UriParametersShouldNotBeStrings", MessageId = "1#", Scope = "member", Target = "Microsoft.Rest.Azure.AzureClientExtensions.#GetLongRunningOperationStatusAsync(Microsoft.Rest.Azure.IAzureClient,System.String,System.Threading.CancellationToken)", Justification = "Needed to pass URL substring")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1032:ImplementStandardExceptionConstructors", Scope = "type", Target = "Microsoft.Rest.Azure.CloudException", Justification = "Exception serialization is not a supported scenario")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1006:DoNotNestGenericTypesInMemberSignatures", Scope = "member", Target = "Microsoft.Rest.Azure.OData.FilterString.#Generate`1(System.Linq.Expressions.Expression`1<System.Func`2<!!0,System.Boolean>>)", Justification = "Using generics to enable intellisense")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720:IdentifiersShouldNotContainTypeNames", MessageId = "long", Scope = "member", Target = "Microsoft.Rest.Azure.IAzureClient.#LongRunningOperationInitialTimeout", Justification = "LongRunning is a known concept")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720:IdentifiersShouldNotContainTypeNames", MessageId = "long", Scope = "member", Target = "Microsoft.Rest.Azure.IAzureClient.#LongRunningOperationRetryTimeout", Justification = "LongRunning is a known concept")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1721:PropertyNamesShouldNotMatchGetMethods", Scope = "member", Target = "Microsoft.Rest.Azure.Resource.#Type", Justification = "Model should match the wire representation")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly", Scope = "member", Target = "Microsoft.Rest.Azure.Resource.#Tags", Justification = "Need to keep to enable serializing as null or empty collection")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1011:ConsiderPassingBaseTypesAsParameters", Scope = "member", Target = "Microsoft.Rest.Azure.OData.FilterString.#Generate`1(System.Linq.Expressions.Expression`1<System.Func`2<!!0,System.Boolean>>)", Justification = "Using generics to enable intellisense")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Globalization", "CA1308:NormalizeStringsToUppercase", Scope = "member", Target = "Microsoft.Rest.Azure.OData.UrlExpressionVisitor.#PrintConstant(System.Object)", Justification = "Server expects the values to be lower-cased")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1006:DoNotNestGenericTypesInMemberSignatures", Scope = "member", Target = "Microsoft.Rest.Azure.AzureClientExtensions.#GetPostOrDeleteOperationResultAsync`1(Microsoft.Rest.Azure.IAzureClient,Microsoft.Rest.Azure.AzureOperationResponse`1<!!0>,System.Threading.CancellationToken)", Justification = "Needed to enable functionality")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1811:AvoidUncalledPrivateCode", Scope = "member", Target = "Microsoft.Rest.Azure.SubResource.#ProvisioningState", Justification = "Used in deserialization")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1811:AvoidUncalledPrivateCode", Scope = "member", Target = "Microsoft.Rest.Azure.Resource.#Id")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1811:AvoidUncalledPrivateCode", Scope = "member", Target = "Microsoft.Rest.Azure.Resource.#Name")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1811:AvoidUncalledPrivateCode", Scope = "member", Target = "Microsoft.Rest.Azure.Resource.#Type")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1811:AvoidUncalledPrivateCode", Scope = "member", Target = "Microsoft.Rest.Azure.Resource.#ProvisioningState")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1020:AvoidNamespacesWithFewTypes", Scope = "namespace", Target = "Microsoft.Rest.Azure.Authentication")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1040:AvoidEmptyInterfaces", Scope = "type", Target = "Microsoft.Rest.Azure.IResource", Justification = "Used during as a marker for JSON serialization")]
[assembly: System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1011:ConsiderPassingBaseTypesAsParameters", Scope = "member", Target = "Microsoft.Rest.Azure.OData.FilterString.#Generate`1(System.Linq.Expressions.Expression`1<System.Func`2<!!0,System.Boolean>>,System.Boolean)")]
