/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package fixtures.http;

import com.microsoft.rest.ServiceCall;
import com.microsoft.rest.ServiceCallback;
import com.microsoft.rest.ServiceResponse;
import fixtures.http.models.Error;
import fixtures.http.models.ErrorException;
import java.io.IOException;
import rx.Observable;

/**
 * An instance of this class provides access to all the operations defined
 * in HttpClientFailures.
 */
public interface HttpClientFailures {
    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error head400() throws ErrorException, IOException;

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> head400Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> head400Async();

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> head400WithServiceResponseAsync();

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error get400() throws ErrorException, IOException;

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> get400Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> get400Async();

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> get400WithServiceResponseAsync();

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error put400() throws ErrorException, IOException;

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> put400Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> put400Async();

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> put400WithServiceResponseAsync();
    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error put400(Boolean booleanValue) throws ErrorException, IOException;

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> put400Async(Boolean booleanValue, final ServiceCallback<Error> serviceCallback);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<Error> put400Async(Boolean booleanValue);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> put400WithServiceResponseAsync(Boolean booleanValue);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error patch400() throws ErrorException, IOException;

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> patch400Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> patch400Async();

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> patch400WithServiceResponseAsync();
    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error patch400(Boolean booleanValue) throws ErrorException, IOException;

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> patch400Async(Boolean booleanValue, final ServiceCallback<Error> serviceCallback);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<Error> patch400Async(Boolean booleanValue);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> patch400WithServiceResponseAsync(Boolean booleanValue);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error post400() throws ErrorException, IOException;

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> post400Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> post400Async();

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> post400WithServiceResponseAsync();
    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error post400(Boolean booleanValue) throws ErrorException, IOException;

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> post400Async(Boolean booleanValue, final ServiceCallback<Error> serviceCallback);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<Error> post400Async(Boolean booleanValue);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> post400WithServiceResponseAsync(Boolean booleanValue);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error delete400() throws ErrorException, IOException;

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> delete400Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> delete400Async();

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> delete400WithServiceResponseAsync();
    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error delete400(Boolean booleanValue) throws ErrorException, IOException;

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> delete400Async(Boolean booleanValue, final ServiceCallback<Error> serviceCallback);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<Error> delete400Async(Boolean booleanValue);

    /**
     * Return 400 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> delete400WithServiceResponseAsync(Boolean booleanValue);

    /**
     * Return 401 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error head401() throws ErrorException, IOException;

    /**
     * Return 401 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> head401Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 401 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> head401Async();

    /**
     * Return 401 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> head401WithServiceResponseAsync();

    /**
     * Return 402 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error get402() throws ErrorException, IOException;

    /**
     * Return 402 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> get402Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 402 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> get402Async();

    /**
     * Return 402 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> get402WithServiceResponseAsync();

    /**
     * Return 403 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error get403() throws ErrorException, IOException;

    /**
     * Return 403 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> get403Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 403 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> get403Async();

    /**
     * Return 403 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> get403WithServiceResponseAsync();

    /**
     * Return 404 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error put404() throws ErrorException, IOException;

    /**
     * Return 404 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> put404Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 404 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> put404Async();

    /**
     * Return 404 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> put404WithServiceResponseAsync();
    /**
     * Return 404 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error put404(Boolean booleanValue) throws ErrorException, IOException;

    /**
     * Return 404 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> put404Async(Boolean booleanValue, final ServiceCallback<Error> serviceCallback);

    /**
     * Return 404 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<Error> put404Async(Boolean booleanValue);

    /**
     * Return 404 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> put404WithServiceResponseAsync(Boolean booleanValue);

    /**
     * Return 405 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error patch405() throws ErrorException, IOException;

    /**
     * Return 405 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> patch405Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 405 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> patch405Async();

    /**
     * Return 405 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> patch405WithServiceResponseAsync();
    /**
     * Return 405 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error patch405(Boolean booleanValue) throws ErrorException, IOException;

    /**
     * Return 405 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> patch405Async(Boolean booleanValue, final ServiceCallback<Error> serviceCallback);

    /**
     * Return 405 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<Error> patch405Async(Boolean booleanValue);

    /**
     * Return 405 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> patch405WithServiceResponseAsync(Boolean booleanValue);

    /**
     * Return 406 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error post406() throws ErrorException, IOException;

    /**
     * Return 406 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> post406Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 406 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> post406Async();

    /**
     * Return 406 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> post406WithServiceResponseAsync();
    /**
     * Return 406 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error post406(Boolean booleanValue) throws ErrorException, IOException;

    /**
     * Return 406 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> post406Async(Boolean booleanValue, final ServiceCallback<Error> serviceCallback);

    /**
     * Return 406 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<Error> post406Async(Boolean booleanValue);

    /**
     * Return 406 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> post406WithServiceResponseAsync(Boolean booleanValue);

    /**
     * Return 407 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error delete407() throws ErrorException, IOException;

    /**
     * Return 407 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> delete407Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 407 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> delete407Async();

    /**
     * Return 407 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> delete407WithServiceResponseAsync();
    /**
     * Return 407 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error delete407(Boolean booleanValue) throws ErrorException, IOException;

    /**
     * Return 407 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> delete407Async(Boolean booleanValue, final ServiceCallback<Error> serviceCallback);

    /**
     * Return 407 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<Error> delete407Async(Boolean booleanValue);

    /**
     * Return 407 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> delete407WithServiceResponseAsync(Boolean booleanValue);

    /**
     * Return 409 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error put409() throws ErrorException, IOException;

    /**
     * Return 409 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> put409Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 409 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> put409Async();

    /**
     * Return 409 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> put409WithServiceResponseAsync();
    /**
     * Return 409 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error put409(Boolean booleanValue) throws ErrorException, IOException;

    /**
     * Return 409 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> put409Async(Boolean booleanValue, final ServiceCallback<Error> serviceCallback);

    /**
     * Return 409 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<Error> put409Async(Boolean booleanValue);

    /**
     * Return 409 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> put409WithServiceResponseAsync(Boolean booleanValue);

    /**
     * Return 410 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error head410() throws ErrorException, IOException;

    /**
     * Return 410 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> head410Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 410 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> head410Async();

    /**
     * Return 410 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> head410WithServiceResponseAsync();

    /**
     * Return 411 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error get411() throws ErrorException, IOException;

    /**
     * Return 411 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> get411Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 411 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> get411Async();

    /**
     * Return 411 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> get411WithServiceResponseAsync();

    /**
     * Return 412 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error get412() throws ErrorException, IOException;

    /**
     * Return 412 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> get412Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 412 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> get412Async();

    /**
     * Return 412 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> get412WithServiceResponseAsync();

    /**
     * Return 413 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error put413() throws ErrorException, IOException;

    /**
     * Return 413 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> put413Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 413 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> put413Async();

    /**
     * Return 413 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> put413WithServiceResponseAsync();
    /**
     * Return 413 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error put413(Boolean booleanValue) throws ErrorException, IOException;

    /**
     * Return 413 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> put413Async(Boolean booleanValue, final ServiceCallback<Error> serviceCallback);

    /**
     * Return 413 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<Error> put413Async(Boolean booleanValue);

    /**
     * Return 413 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> put413WithServiceResponseAsync(Boolean booleanValue);

    /**
     * Return 414 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error patch414() throws ErrorException, IOException;

    /**
     * Return 414 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> patch414Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 414 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> patch414Async();

    /**
     * Return 414 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> patch414WithServiceResponseAsync();
    /**
     * Return 414 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error patch414(Boolean booleanValue) throws ErrorException, IOException;

    /**
     * Return 414 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> patch414Async(Boolean booleanValue, final ServiceCallback<Error> serviceCallback);

    /**
     * Return 414 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<Error> patch414Async(Boolean booleanValue);

    /**
     * Return 414 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> patch414WithServiceResponseAsync(Boolean booleanValue);

    /**
     * Return 415 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error post415() throws ErrorException, IOException;

    /**
     * Return 415 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> post415Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 415 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> post415Async();

    /**
     * Return 415 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> post415WithServiceResponseAsync();
    /**
     * Return 415 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error post415(Boolean booleanValue) throws ErrorException, IOException;

    /**
     * Return 415 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> post415Async(Boolean booleanValue, final ServiceCallback<Error> serviceCallback);

    /**
     * Return 415 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<Error> post415Async(Boolean booleanValue);

    /**
     * Return 415 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> post415WithServiceResponseAsync(Boolean booleanValue);

    /**
     * Return 416 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error get416() throws ErrorException, IOException;

    /**
     * Return 416 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> get416Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 416 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> get416Async();

    /**
     * Return 416 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> get416WithServiceResponseAsync();

    /**
     * Return 417 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error delete417() throws ErrorException, IOException;

    /**
     * Return 417 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> delete417Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 417 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> delete417Async();

    /**
     * Return 417 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> delete417WithServiceResponseAsync();
    /**
     * Return 417 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error delete417(Boolean booleanValue) throws ErrorException, IOException;

    /**
     * Return 417 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> delete417Async(Boolean booleanValue, final ServiceCallback<Error> serviceCallback);

    /**
     * Return 417 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<Error> delete417Async(Boolean booleanValue);

    /**
     * Return 417 status code - should be represented in the client as an error.
     *
     * @param booleanValue Simple boolean value true
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> delete417WithServiceResponseAsync(Boolean booleanValue);

    /**
     * Return 429 status code - should be represented in the client as an error.
     *
     * @throws ErrorException exception thrown from REST call
     * @throws IOException exception thrown from serialization/deserialization
     * @return the Error object if successful.
     */
    Error head429() throws ErrorException, IOException;

    /**
     * Return 429 status code - should be represented in the client as an error.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<Error> head429Async(final ServiceCallback<Error> serviceCallback);

    /**
     * Return 429 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<Error> head429Async();

    /**
     * Return 429 status code - should be represented in the client as an error.
     *
     * @return the observable to the Error object
     */
    Observable<ServiceResponse<Error>> head429WithServiceResponseAsync();

}
